<?php
if (!defined('DC_CONTEXT_ADMIN')) { return; }

$core->addBehavior('adminPostFormSidebar',array('shortURLBehaviors','shortURLDisplay'));
if ($core->plugins->moduleExists('pages')) {
	$core->addBehavior('adminPageFormSidebar',array('shortURLBehaviors','shortURLDisplay'));
}
if ($core->plugins->moduleExists('gallery')) {
	$core->addBehavior('adminGalleryFormSidebar',array('shortURLBehaviors','shortURLDisplay'));
	$core->addBehavior('adminGalleryItemFormSidebar',array('shortURLBehaviors','shortURLDisplay'));
}

$core->addBehavior('adminBlogPreferencesForm',array('shortURLBehaviors', 'adminBlogPreferencesForm'));
$core->addBehavior('adminBeforeBlogSettingsUpdate',array('shortURLBehaviors', 'adminBeforeBlogSettingsUpdate'));

# BEHAVIORS
class shortURLBehaviors
{
	public static function shortURLDisplay(&$post)
	{
		if ($post && $GLOBALS['core']->blog->settings->shortURLEnabled) {
			$url = $GLOBALS['core']->blog->url.$GLOBALS['core']->url->getBase('shortURL').'/'.$post->post_id;
			echo
			'<h3>'.__('Short URL:').'</h3>'.
			'<p><a href="'.$url.'">'.$url.'</a></p>';
		}
	}

	public static function adminBlogPreferencesForm(&$core)
	{
		$activate = $core->blog->settings->shortURLEnabled ? true : false;
		$prefix = $core->blog->settings->shortURLPrefix;
		$backCompatibility = $core->blog->settings->shortURLBackCompatibility ? true : false;

		echo "<fieldset><legend>".__('Short URL')."</legend>\n";
		echo "<p><label class=\"classic\">".form::checkbox('enableShortURL','1',$activate)."\n".
			__('Enable short URL system.')."</label></p>\n";
		echo "<p><label class=\"classic\">".__('Prefix to use in short URLs:')."\n".
			form::field('shortURLPrefix',10,20,$prefix)."</label></p>\n";
		echo "<p><label class=\"classic\">".form::checkbox('backCompatibleShortURL','1',$backCompatibility)."\n".
			__('Provide backwards compatibility (ie, support postid type URL).')."</label></p>\n";
		echo "</fieldset>\n";
	}
	
	public static function adminBeforeBlogSettingsUpdate(&$blog_settings)
	{
		$enabled = empty($_POST['enableShortURL']) ? false : true;
		$backCompatibility = empty($_POST['backCompatibleShortURL']) ? false : true;
		$prefix = empty($_POST['shortURLPrefix']) ? 'shurl' : $_POST['shortURLPrefix'];
		
		$blog_settings->setNamespace('shortURL');
		$blog_settings->put(
			'shortURLEnabled',
			$enabled,
			'boolean',
			'Enable short URL system');
		$blog_settings->put(
			'shortURLPrefix',
			$prefix,
			'string',
			'Short URL system prefix');
		$blog_settings->put(
			'shortURLBackCompatibility',
			$backCompatibility,
			'boolean',
			'Still support the old URL system');
		$blog_settings->setNamespace('system');
	}
	
}
?>
